// Copyright (C) 1999 Ingo Ruhnke <grumbel@gmx.de>, see README.TXT for details

#include <cassert>

#include "entrance.hh"

CL_Surface* Entrance::surface;

Entrance::Entrance(int x, int y)
{
  last_release = 0;
  x_pos = x;
  y_pos = y;
}

bool
Entrance::pingu_ready()
{
  if (last_release + 1000 > CL_System::get_time()) {
    return false;
  } else {
    last_release = CL_System::get_time();
    return true;
  }
}

Pingu*
Entrance::get_pingu()
{
  return new Pingu(x_pos, y_pos);
}

void
Entrance::draw()
{
  surface->put_screen(x_pos-32, y_pos-16);
}

void
Entrance::draw_offset(int x, int y)
{
  surface->put_screen(x_pos-32 + x, y_pos-16 + y);
}

void 
Entrance::load_data(CL_ResourceManager* resource)
{
  surface = CL_Res_Surface::load("Game/entrance", *resource);
  assert(surface);
}

/* EOF */
