// Copyright (C) 1999 Ingo Ruhnke <grumbel@gmx.de>, see README.TXT for details

#include <cassert>

#include "exit.hh"

CL_Surface* Exit::surface;

Exit::Exit(int x, int y)
{
  x_pos = x;
  y_pos = y;
}

void
Exit::draw()
{
  surface->put_screen(x_pos, y_pos);
}

void
Exit::draw_offset(int x, int y)
{
  surface->put_screen(x_pos + x, y_pos + y);
}

void 
Exit::load_data(CL_ResourceManager* resource)
{
  surface = CL_Res_Surface::load("Game/exit", *resource);
  assert(surface);
}

/* EOF */
