// Copyright (C) 1999 Ingo Ruhnke <grumbel@gmx.de>, see README.TXT for details

#include <cassert>
#include <ClanLib/clanlib.h>
#include <ClanLib/clanlayer2.h>

#include "pingu.hh"
#include "pingu_actions/pingu_actions.hh"

// define the other things
ColMap* Pingu::colmap;
CL_ResourceManager* Pingu::resource;

Pingu::Pingu()
{
  data.x_pos = 50;
  data.y_pos = 50;
  set_action(new Walker);
  action->set_pingu_data(data);
}

Pingu::Pingu(int x, int y)
{
  data.x_pos = x;
  data.y_pos = y;
  set_action(new Walker);
  action->set_pingu_data(data);
}

int
Pingu::get_x()
{
  return data.x_pos;
}

int
Pingu::get_y()
{
  return data.y_pos;
}

void 
Pingu::set_pos(int x, int y)
{
  data.x_pos = x;
  data.y_pos = y;
}

void
Pingu::set_colmap(ColMap* a)
{
  colmap = a;
}

void
Pingu::set_map(PinguMap* a)
{
}

void 
Pingu::load_data(CL_ResourceManager* res)
{
  assert(res);
  resource = res;
}

int
Pingu::set_action(PinguAction* act)
{
  assert(act);
  action = act;
  action->set_pingu_data(data);
}

bool
Pingu::is_over(int x, int y)
{
  //  if (!alive)
  //  return false;

  if (data.x_pos - 16 < x && data.x_pos + 16 > x &&
      data.y_pos - 32 < y && data.y_pos > y) {
    return true;
  } else {
    return false;
  }
}

void
Pingu::let_move(void)
{
  assert(action);

  action->set_colmap(colmap);
  action->let_move();
}

void
Pingu::draw_offset(int x, int y)
{
  action->draw_offset(x, y);
}

/* EOF */
