// Copyright (C) 1999 Ingo Ruhnke <grumbel@gmx.de>, see README.TXT for details

#include <cassert>

#include "pingu_action.hh"

CL_Surface* PinguAction::surface;
CL_ResourceManager* PinguAction::resource;
ColMap* PinguAction::colmap;

void 
PinguAction::set_colmap(ColMap* cm)
{
  colmap = cm;
  assert(colmap);
}

void
PinguAction::load_data(CL_ResourceManager* res)
{
  resource = res;
  assert(resource);
}

void
PinguAction::set_pingu_data(PinguData& pingu_data)
{
  data = &pingu_data;
  assert(data);
}

int
PinguAction::rel_getpixel(int x, int y)
{
  assert(colmap);
  return colmap->getpixel(data->x_pos + (x * data->direction), (data->y_pos) - y);
}

void
PinguAction::draw_offset(int x, int y)
{
  assert(surface);
  surface->put_screen(data->x_pos + x -16, data->y_pos + y -32);
}

/* EOF */
