// Copyright (C) 1999 Ingo Ruhnke <grumbel@gmx.de>, see README.TXT for details

#ifndef PINGU_ACTION_HH
#define PINGU_ACTION_HH

#include <ClanLib/clanlib.h>
#include <ClanLib/clanlayer2.h>

#include "pingu_data.hh"
#include "colmap.hh"
#include "pingumap.hh"

class PinguAction
{
protected:
  static CL_Surface* surface;
  static CL_ResourceManager* resource;
  static ColMap* colmap;
  PinguData* data;
public:
  virtual void let_move() = 0;     // The "AI" of the pingu, there is no default AI
  virtual void draw_offset(int x, int y); //
  void set_pingu_data(PinguData& );
  int  rel_getpixel(int x, int y);

  // some static variables and functions
  // static CL_Surface* sprite;
  static void set_colmap(ColMap*);
  static void set_map(PinguMap*);
  static void load_data(CL_ResourceManager*);
};

#endif

/* EOF */
