// Copyright (C) 1998 Ingo Ruhnke <grumbel@gmx.de>, see README.TXT for details

#include "globals.hh"
#include "pingutilemap.hh"

PinguTileMap::PinguTileMap(PLF* data, CL_ResourceManager* resource)
{
  tile_provider = new PinguTileProvider(resource);
  map.resize(15);
  for(int i=0; i < map.size(); ++i) {
    map[i].resize(20);
  }
  load(data->get_fg(), resource);
}

PinguTileMap::~PinguTileMap()
{
}

void
PinguTileMap::mark_dirty(int x, int y, int w, int h)
{
  //  if (x > 800 || x < 0 || y < 0 | y > 600)
  //    return;
  return; // because this secfaclts
  map[y/32][x/32].set_redraw(true);
}

int
PinguTileMap::load(const char* filename, CL_ResourceManager* resource)
{
  ifstream in(filename);

  if (!in) {
    perror(filename);
    exit(EXIT_FAILURE);
  }

  char temp[255];

  for(int y=0; y < map.size(); ++y) {
    for(int x=0; x < map[y].size(); ++x) {
      in >> temp;
      map[y][x].load(atoi(temp), tile_provider);
    }
  }
  return 0;
}

int
PinguTileMap::load(ifstream* in)
{
  int w,h;

  (*in) >> w >> h;

  map.resize(h);
  
  for(int i=0; i < map.size(); ++i)
    map[i].resize(i);
}

void
PinguTileMap::put_screen(int x, int y)
{
  PinguTileMap::draw();
}

/*
ColMap
PinguTileMap::get_colmap()
{
}*/

void
PinguTileMap::draw_offset(int of_x, int of_y)
{
  for(int y=0; y < map.size(); ++y) {
    for(int x=0; x < map[y].size(); ++x) {
      if (use_dirty_tiles && map[y][x].needs_redraw()) {
	map[y][x].draw(x*32 + of_x, y*32 + of_y);
	map[y][x].set_redraw(false);
      } else if (!use_dirty_tiles) {
	map[y][x].draw(x*32 + of_x, y*32 + of_y);
      }
    }
  }
}

void
PinguTileMap::draw()
{
  for(int y=0; y < map.size(); ++y) {
    for(int x=0; x < map[y].size(); ++x) {
      if (use_dirty_tiles && map[y][x].needs_redraw()) {
	map[y][x].draw(x*32,y*32);
	map[y][x].set_redraw(false);
      } else if (!use_dirty_tiles) {
	map[y][x].draw(x*32,y*32);
      }
    }
  }
}

void
PinguTileMap::start_anim()
{
}

void
PinguTileMap::stop_anim()
{
}

/* EOF */
